'use strict';

const fs = require('fs')

module.exports = {
  load() { },

  unload() { },

  messages: {
    'inspect'() {
      Editor.log('---------Prefab和场景 资源缺失检查器---------');
      Editor.log('○ 开始检查');

      // 加载所有预制体
      Editor.assetdb.queryAssets('db://assets/**\/*', ['prefab', 'scene'], (err, prefabArray) => {
        Editor.log('预制体+场景数量 :', prefabArray.length);

        let isCorrect = true;
        prefabArray.forEach((asset) => {

          // 检测资源缺失
          const data = fs.readFileSync(asset.path, 'utf-8');
          const uuidMatchArray = data.match(/"__uuid__": ?"[\w\-]+"/g);
          if (uuidMatchArray) {
            const uuidArray = data.match(/"__uuid__": ?"[\w\-]+"/g).map(v => v.split('"')[3]);
            for (let uuid of uuidArray) {
              const isExist = Editor.assetdb.existsByUuid(uuid);
              if (!isExist) {
                Editor.log(asset.url + ': 资源缺失！' + `"${uuid}"`);
                isCorrect = false;
                return;
              }
            }
          }

          // 检测代码文件缺失
          const typeMatchArray = data.match(/"__type__": ?"[^"]+"/g);
          if (typeMatchArray) {
            const typeArray = data.match(/"__type__": ?"[^"]+"/g).map(v => v.split('"')[3]);
            for (let type of typeArray) {
              const uuid = Editor.Utils.UuidUtils.decompressUuid(type);
              if (type.length !== uuid.length) {
                const isExist = Editor.assetdb.existsByUuid(uuid);
                if (!isExist) {
                  Editor.log(asset.url + ': 代码缺失！' + `"${uuid}"`);
                  isCorrect = false;
                  return;
                }
              }
            }
          }

        })

        // 如果都不缺失则打印
        if (isCorrect) {
          Editor.log('● 检查完毕，恭喜！资源完备～');
        } else {
          Editor.log('⊕ 检查完毕');
        }
        Editor.log('------------------------------------------');
      })
    }
  },
};